/*****************************************************************************/
/* XKeyWrap - A simple keyboard wrapper on X Window System.                  */
/*                                                                           */
/* XKeyWrap Copyright (C) 1999 Sakai Hiroaki.                                */
/* All Rights Reserved.                                                      */
/*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>

typedef struct _List * List;
typedef struct _ListData * ListPointer;

ListPointer ListGetStart(List this);
ListPointer ListGetEnd(List this);
ListPointer ListGetNext(ListPointer pointer);
char ListGetAction(ListPointer pointer);
KeySym ListGetKey(ListPointer pointer);
unsigned int ListGetState(ListPointer pointer);
Time ListGetTimer(ListPointer pointer);
ListPointer ListAddToStart(List this, char action, KeySym key_sym,
			   unsigned int state, Time timer);
ListPointer ListAddToEnd(List this, char action, KeySym key_sym,
			 unsigned int state, Time timer);
ListPointer ListAdd(List this, ListPointer pointer,
		    char action, KeySym key_sym,
		    unsigned int state, Time timer);
void ListClear(List this);
List ListCreate();
void ListDestroy(List this);

/*****************************************************************************/
/* End of file.                                                              */
/*****************************************************************************/
