.\" 
.\" XKeyWrap - A simple keyboard wrapper on X Window System.
.\" 
.\" XKeyWrap Copyright (C) 1999-2001 Sakai Hiroaki.
.\" All Rights Reserved.
.\" 
.TH XKEYWRAP 1 "Release 6" "X Version 11"

.SH NAME

XKeyWrap - Record and play key sequence.

.SH SYNOPSIS

.B xkeywrap [XKeyWrap's options] [-x Application [Application's options...]]

.SH DESCRIPTION

XKeyWrap is a wrapper of key sequence between keyboard and an application
(ex.emacs).
XKeyWrap can record and play key sequence in real time.
And XKeyWrap can send key sequence to an application on other X server
over the network.

.SH RESOURCES

You can use all of the standard X-Toolkit resources.

.SH OPTIONS

You can use all of the standard X-Toolkit options.

.TP 8
.B -display [displayname]

This option specifies the name of the X server to use.

.TP 8
.B -geometry [+X+Y]

This option specifies the placement of the window on the screen.

.TP 8
.B -name [name]

This option specifies the name of the application.

.TP 8
.B -background [color], -bg [color]

This option specifies background color of the window.

.TP 8
.B -h, -help

Output help message.

.TP 8
.B -readme

Output README for informations and examples about using XKeyWrap.

.TP 8
.B -copyright

Output COPYRIGHT of XKeyWrap.

.TP 8
.B -p, -play

XKeyWrap starts playing key sequence at start.

.TP 8
.B -r, -repeat

Set auto repeat mode at start.

.TP 8
.B -rec, -record

XKeyWrap starts recording key sequence at start.

.TP 8
.B -pause

XKeyWrap is paused at start.

.TP 8
.B -q, -quit

XKeyWrap exits when child process exits. And Child process exits
when XKeyWrap exits.

.TP 8
.B -f, -file [filename]

This option specifies file to save and load key sequence.

.TP 8
.B -s, -speed [speed]

This option specifies speed to play key sequence from 0 to 9.
Default speed is 5.

.TP 8
.B -output-display [displayname]

This option specifies the display to send key sequence.

.TP 8
.B -output-window [windowid]

This option specifies the window to send key sequence.

.TP 8
.B -x [Application [Application options...]]

An application starts as child process of XKeyWrap and XKeyWrap is
connected to the application and send key sequence to it.
(Ex. xkeywrap -x emacs sample.txt)

.SH MENU

.TP 8
.B Select

Select the window to output key sequence.
Move the mouse pointer to the window and click left button on the window.

.TP 8
.B Parent

Change the window to output key sequence to the parent of the window.

.TP 8
.B Child

Change the window to output key sequence to one of the children of the window.

.TP 8
.B Next

Change the window to output key sequence to other child.
This menu is selected next to selecting Child menu.

.TP 8
.B Clear

Clear the recorded key sequence data.

.TP 8
.B Record

Start recording key sequence from the keyboard.
If key sequence data exists,
XKeyWrap add key sequence to the start of the old key sequence data.
If you select this menu while recording,
XKeyWrap adds key sequence to the end of the old key sequence data.
If you select this menu while playing, you can insert key sequence
into the old key sequence data.

.TP 8
.B Stop

Stop recording and playing.

.TP 8
.B Play

Play the recorded key sequence in real time.
If you select this menu while playing, XKeyWrap increases the times of playing.

.TP 8
.B Pause

Pause recording or playing.

.TP 8
.B Repeat

Auto repeating at playing the recorded key sequence.

.TP 8
.B +

Change the speed to play key sequence faster.

.TP 8
.B -

Change the speed to play key sequence more slow.

.TP 8
.B Save

Save the recorded key sequence data to file.

.TP 8
.B Load

Load the key sequence data from file.

.TP 8
.B Quit

XKeyWrap exits.

.PP

.SH EXAMPLES

.TP 8
.B % xkeywrap

- XKeyWrap starts.
.br
- Click Select menu of XKeyWrap and click on the window to send key sequence.
.br
- Key inputs to XKeyWrap are sent to the window.

.TP 8
.B % xkeywrap -x emacs

- Emacs and XKeyWrap start.
.br
- You put the mouse pointer on XKeyWrap and input some words.
.br
- The words are sent to emacs.
.br
- You can record and play the key sequence by XKeyWrap.

.TP 8
.B % xkeywrap -f example.dat -x emacs -geometry 80x20 text.txt

- Emacs opens file "text.txt" and starts with 80x20 window.
.br
- XKeyWrap starts. If example.dat exists, XKeyWrap reads it.
.br
- If you select Play menu, XKeyWrap plays it.
.br
- If you select Save menu, XKeyWrap saves key sequence to file "example.dat".

.TP 8
.B % xkeywrap -display wrongdisp:0 -output-display gooddisp:0

- XKeyWrap starts on "wrongdisp".
.br
- Click Select menu of XKeyWrap and click on the window on "gooddisp".
.br
- Key inputs to XKeyWrap are sent to the window on "gooddisp".
(XKeyWrap can send key sequence to an application running on other X server
over the network)

.TP 8
.B % xkeywrap -f example.dat -display wrongdisp:0 -output-display gooddisp:0 -x emacs -display gooddisp:0 -geometry 80x20 text.txt

- Emacs starts on "gooddisp".
.br
- XKeyWrap starts on "wrongdisp".
.br
- XKeyWrap search a new window on "gooddisp", and find emacs on it.
.br
- Key inputs to XKeyWrap are sent to emacs.
(XKeyWrap can send key sequence to an application running on other X server
over the network)

.SH Q AND A

.TP 8
.B Q. I cannot connect XKeyWrap to XTerm (or other application).

XTerm do not permit to receive event from outside as default.
.br
If you want to use XTerm with XKeyWrap, you have to set allowSendEvents
resource. add this line to .Xdefaults.
.br
.B XTerm*allowSendEvents: true
.br
or
.br
.B xterm*allowSendEvents: true
.br
But, if allowSendEvent is true, XTerm receives all events from outside,
and everyone can operate XTerm on your machine from the machine which is
permitted to connect to the X server of your machine by xhost(1).
If you do it, be very careful of setting xhost(1).
.br
If you want to permit to connect XKeyWrap to all applications,
add this line to .Xdefaults.
.br
.B *allowSendEvents: true
.br
But, when you do it, all X applications receives all events from outside,
and everyone can operate them on your machine from the machine which is
permitted to connect to the X server of your machine by xhost(1).
If you do it, be very careful of setting xhost(1).

.TP 8
.B Q. I read term of Demonstration in README and try it, but it does not run correctly.

This demonstration was recorded with Japanese 106 keyboard.
If your keyboard is different from it, you can see this demonstration,
but, this demonstration runs more or less curiously.

.TP 8
.B Q. Though allowSendEvents resource is set correctly, I cannot connect XKeyWrap to an application.

Try Parent menu as below,
.br
first, click Select menu and select the application window.
.br
Second, put the mouse pointer on XKeyWrap and try to hit some keys.
.br
Third, if you cannot operate the application from XKeyWrap,
click Parent menu some times and try to hit some keys again.

.SH SEE ALSO

X(1)
.br
If you want to read more informations and examples about using XKeyWrap,
run XKeyWrap with -readme option.

.SH BUGS

XKeyWrap runs more or less curiously between systems with different keyboards.
(Ex. If the keyboard of your system is 101 keyboard,
XKeyWrap can play the data recorded with Japanese 106 keyboard, but,
more or less curiously)

.SH AUTHOR

Programed by
.B Sakai Hiroaki.
.br
E-Mail : sakai@seki.ee.kagu.sut.ac.jp, hsakai@m8.people.or.jp
.br
http://www.seki.ee.kagu.sut.ac.jp/~sakai/myfreesoft/index.html
.br
http://hp.vector.co.jp/authors/VA014157/myfreesoft/index.html
.br
http://www.people.or.jp/~hsakai/myfreesoft/index.html

.SH COPYRIGHT
XKeyWrap Copyright (C) 1999-2001 Sakai Hiroaki.
.br
All Rights Reserved.
.br
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.
